/*日夜间共用js*/

/* 对于复杂的js，若日夜间代码仅有一两行日夜间的差距，可使用 ifeng.isNightMode(); 进行判断区分，将该复杂js代码放入此js，利于维护 */

var     EVENT_IMG_WIDTH = 0,            //运营位活动图片宽
        EVENT_IMG_HEIGHT = 0,           //运营位活动图片高
        EVENT_IMG_RADIO = 698 / 256;    //运营位活动图片宽高比
        /*房产相关*/
        houselp_p='<!-- IFENG_DOC_HOUSEBUILDING -->',
        housefy_p='<!-- IFENG_DOC_HOUSERESOURCES -->',
        housexq_p='<!-- IFENG_DOC_HOUSEESTATE -->',
        housedc_p='<!-- IFENG_DOC_HOUSESURVEY -->',
        card_ad_p = '<!-- IFENG_DOC_CARD -->',
        househd_p='<!-- IFENG_DOC_HOUSEACTIVITY -->';
        jumpUrls = [];

// 获取自媒体信息底部的Y值
function setAuthorTitleBottomY(){
    var contentTop = 0;
    var detail_declare = document.getElementById('detail_declare');
    var summary_parent = document.getElementById('summary_parent');
    var content = document.getElementById('content');
    if(detail_declare && detail_declare.style.display == 'block') {
        contentTop = detail_declare.offsetTop ;
    } else if (summary_parent && summary_parent.style.display == 'inline-block'){
        contentTop = summary_parent.offsetTop ;
    }else {
        contentTop = content.offsetTop ;
    }
    ifeng.setAuthorTitleBottomYDp(contentTop);
    console.log("setAuthorTitleBottomYDp : " + contentTop);
}

//改变关注图标状态 （于Java调用）
function changeSubButtonImg(subState) {
    try{
        var newsType = ifeng.getNewsType();
        subSourceSuccessForDoc().call(null, subState);
    } catch (e) {
       console.log("error:"+e);
    }
}


//显示事件运营位图片 （于Java调用）
function showBottomEventImg(imgUrl,linkType,linkUrl,isAuth,staticId) {
    EVENT_IMG_WIDTH = SCREEN_WIDTH - 24;
    EVENT_IMG_HEIGHT = Math.round(EVENT_IMG_WIDTH / EVENT_IMG_RADIO);
    var eventImgWrapper = document.getElementById('event_img_wrapper');
    eventImgWrapper.style.width = EVENT_IMG_WIDTH + 2 + 'px';
    eventImgWrapper.style.display = 'block';
    eventImgWrapper.onclick = function() {
       ifeng.onEventImgClick(linkType,linkUrl,isAuth,staticId);
    }
    var eventImage = document.getElementById('event_img');
    eventImage.style.width = EVENT_IMG_WIDTH + 'px';
    eventImage.style.height = EVENT_IMG_HEIGHT + 'px';
    eventImage.style.backgroundImage = 'url(' + imgUrl + ')';
}

function removeNotePreEmptyPBottomSpace(className) {

    if(!className || className == "" || className == 'undefined') {
        return;
    }

    try {
        //如果前一个标签是空p标签，将其下边距去掉
        var nodeList = content.getElementsByClassName(className)
        if(nodeList){
            for(j=0;j<nodeList.length;j++) {
                 var pre = nodeList[j].previousSibling;
                 if(pre && pre.tagName == 'P' && pre.innerText == ""){
                     pre.style.paddingBottom = "0px";
                     pre.style.marginBottom = "0px";
                     console.log("fixErrorSpace success");
                 } else if(className == 'survey_classes') {
                    fixSurveyErrorTopSpace(pre);
                 }
            }
        }
    } catch (e) {
        console.log("removeNotePreEmptyPBottomSpace error : " + e);
    }
}

function fixSurveyErrorTopSpace(preNode) {
    if(!preNode) {
        return;
    }

    try {
        if(preNode.nodeType == 1){
            if(!preNode.style.paddingBottom && !preNode.style.marginBottom) {
                preNode.style.paddingBottom = "0px";
                preNode.style.marginBottom = "16px";
            }
        } else {
            fixSurveyErrorTopSpace(preNode.previousSibling);
        }
    } catch (e) {
        console.log("fixErrorTopSpace error : " + e);
    }
}

//修复正文异常边距
function fixErrorSpace() {
    var content = document.getElementById("content");

    removeNotePreEmptyPBottomSpace("video");

    fixTopVideoOrImgTopSpace();

    //移除正文最后一个元素的下边距
    removeLastElementBottomSpace(content);
    //重置音频位置
    initAudio();
    console.log("fixErrorSpace");
}

/*移除该元素及其最后一个子元素底部的padding和margin*/
function removeLastElementBottomSpace(parent) {
    if(parent) {

        parent.style.paddingBottom = "0px";
        parent.style.marginBottom = "0px";

        var children = parent.children;
        if(children && children.length > 0) {
            var lastChildren = children[children.length - 1];
            removeLastElementBottomSpace(lastChildren);
        }
    }
}

//当视频或图片开头时，调整视频和图片的上边距
function fixTopVideoOrImgTopSpace() {
    var detail_declare = document.getElementById("detail_declare");
    var content = document.getElementById("content");
    var allNodeList = content.childNodes;
    if(allNodeList.length <= 1) {
        return;
    }

    //视频上面有一个空p标签占位，所以需查找两个标签
    for(i=0;i<2;i++) {
        var node = allNodeList[i];
        if(detail_declare.style.display == 'none') {
           //当不展示转载声明时，正文由视频开头，需要调整视频上边距为4px
           if(node.id == "videoContent") {
                node.style.paddingTop = "0px";
                node.style.marginTop = "4px";
                console.log("fixTopVideoOrImgTopSpace:fix top video/img space success with no declare.");
                break;
           }
        } else {
            //当展示转载声明时，正文由视频或图片开头，需要调整上边距为3px
            if(node.id == "videoContent" || node.id == "imgPlaceholder") {
                node.style.paddingTop = "0px";
                node.style.marginTop = "3px";
                console.log("fixTopVideoOrImgTopSpace:fix top video/img space success.");
                break;
            }
        }
    }
    console.log("fixTopVideoOrImgTopSpace");
}


/*房产电话咨询调用*/
function houseCallPhone(tag,telephoneStr){
    ifeng.houseTelephone(tag,"'"+telephoneStr+"'");
}
/*房卡卡片活动跳转调用*/
function toHouseCardDetail(houseLinkUrl){
    ifeng.houseLink(houseLinkUrl);
}
/*房产频道房源卡片相关*/
function buildHouseCard(content){
    var houseCardLPStr = datas.getHouseCardLPJson();
    content = handleHouseContent(content,houselp_p,houseCardLPStr);

    var houseCardFYStr = datas.getHouseCardFYJson();
    content = handleHouseContent(content,housefy_p,houseCardFYStr);

    var houseCardXQStr = datas.getHouseCardXQJson();
    content = handleHouseContent(content,housexq_p,houseCardXQStr);

    var houseCardHDStr = datas.getHouseCardHDJson();
    content = handleHouseContent(content,househd_p,houseCardHDStr);

    var houseCardDCStr = datas.getHouseCardDCJson();
    content = handleHouseContent(content,housedc_p,houseCardDCStr);
    return content;
}
function handleHouseContent(content,flag_p,sourceJson){
    if(sourceJson != null && sourceJson != "null" && sourceJson != "" && sourceJson != 'undefined'&&Object.prototype.toString.call(sourceJson) == '[object String]'){
        var houseCardList = JSON.parse(sourceJson);
        content = handle_survey_position(content,flag_p,houseCardList.length,
                function(i) {
                    return houseCardList[i].html;
                });
    }
    return content;
}

//初始化文章标题
function initNewsTitle() {
    var newsType = ifeng.getNewsType();
    document.getElementById('title').innerHTML = datas.getTitle();
    return content
}

//稿源信息
function initSource(datas){
    try{
        var wrapper = document.getElementById('time-and-source-panel');
        wrapper.onclick = function(event) {
            ifeng.gotoSubscribe("");
            event.stopPropagation();
        }
        // 头像布局
        var iconWrap = document.getElementById('cir');
        var icon = document.getElementById('source_icon');
        var iconTag = document.getElementById('source_tag');
        // 自媒体名布局
        var source = document.getElementById('source');
        var catesource = document.getElementById('catesource');
        var line = document.getElementById('verticalline');
        // 原创、时间、简介布局
        var timeLayout = document.getElementById('wrap_time_original');
        var time = document.getElementById('time');
        var src_infonormal = document.getElementById('src_infro');
        var original_content = document.getElementById('original_content');

        var catesource_str,type,cateName,imgPath,source_tag,declare,srcInfo,originalName;
        // 关注按钮
        var subButton = document.getElementById('subscribe');

        var detail_declare = document.getElementById('detail_declare');
        if(datas.getSubscribe()){
            catesource_str = datas.getSubscribe().getCateSourceForJs();
            type = datas.getSubscribe().getType();
            cateName = datas.getSubscribe().getCatename();
            imgPath = datas.getSubscribe().getLogo();
            originalName = datas.getSubscribe().getOriginalName();

            if (ifeng.isNightMode()) {
                source_tag = datas.getSubscribe().getHonorImgNight();
            } else {
                source_tag = datas.getSubscribe().getHonorImg();
            }

            declare = datas.getSubscribe().getDeclare();
            srcInfo = datas.getSubscribe().getDescription();
        }

        var newsType = ifeng.getNewsType();

        // 大风号标签
        if(catesource_str && typeof(catesource_str)!="undefined" && catesource_str!=null && catesource_str!=""){
            catesource.style.display = "block";
            line.style.display = "block";

            catesource.innerHTML = catesource_str;
        }else{
            catesource.style.display = "none";
            line.style.display = "none";
        }

        // 自媒体名
        if(typeof(cateName)!="undefined"){
           source.innerHTML = cateName;
        }else{
           source.style.display = "none";
        }

        // 时间
        if (datas.getUpdateTimeForDetail() != null && datas.getUpdateTimeForDetail() != "") {
            time.innerHTML = datas.getUpdateTimeForDetail();
        } else {
            time.style.display = "none";
        }

        //原创标签
        if (typeof(originalName)!="undefined" && originalName != null && originalName != "") {
              if (original_content != null) {
                   original_content.style.display="block";
                   original_content.innerHTML = originalName;
              }
        } else{
              if (original_content != null) {
                    original_content.style.display="none";
              }
              time.style.marginLeft = 0;
        }

        if(typeof(type)!="undefined"){
            Ground.isSubscribe(subSourceSuccessForDoc(),"");
            // 自媒体简介
            if (src_infonormal != null) {
                if (typeof(srcInfo) != "undefined" && srcInfo != null && srcInfo != "") {
                    src_infonormal.innerHTML = srcInfo;
                    if (original_content.style.display == "none" && time.style.display == "none") {
                        src_infonormal.style.marginLeft = 0;
                    }
                } else {
                    src_infonormal.style.display="none";
                }
            }
        }else{
            subButton.style.display = "none";
        }

        // 隐藏时间父布局
        var isTimeLayoutDisplayNone =  original_content.style.display == "none"
                            && time.style.display == "none"
                            && src_infonormal.style.display == "none";;
        if (isTimeLayoutDisplayNone) {
            timeLayout.style.display="none";
        }

        // 设置自媒体头像
        if(typeof(imgPath)!="undefined" && imgPath!=0){
            icon.style.display = 'block';
            Ground.loadUserHeadImageDirectly(imgPath, null,
                loadImageSuccessInterceptor(icon),
                loadSubscriptImageFailInterceptor(icon,imgPath), 'forceLoad');
        }
        // 去掉用自媒体名首字作为logo
//        else if(cateName && typeof(cateName)!="undefined"){
//            icon.style.display = 'block';
//            Ground.loadImageDirectly(cateName, null,
//                loadImageSuccessInterceptor(icon),
//                loadSubscriptImageFailInterceptor(icon,cateName), 'forceLoad');
//        }
        else{
            iconWrap.style.display = "none";
            icon.style.display = "none";
        }

        // 荣誉认证V
        if(source_tag && typeof(source_tag)!="undefined" && source_tag!=null && source_tag!=""&&source_tag != 0){
            iconTag.style.display = "block";
            Ground.loadImageDirectly(source_tag, null,
                loadImageSuccessInterceptor(iconTag),
                loadSubscriptImageFailInterceptor(iconTag,source_tag), 'forceLoad');
        }

        subButton.onclick = function(event) {
            Ground.addSubscribe(subSourceSuccessForDoc(),"");
            event.stopPropagation();
        };

        if(subscribe.getForbidFollow()=='1'){
            subButton.style.display = "none";
        }

        if(typeof(declare)!="undefined" && declare!=0) {
            detail_declare.style.display = "block";
            detail_declare.innerHTML = declare;
            document.getElementById('content').style.paddingTop = "0px";
        }
    }catch(e){
        console.log("error:"+e);
    }
}

/*正文 切换关注按钮状态*/
function subSourceSuccessForDoc() {
    return function(subState){
        var subButton = document.getElementById('subscribe');
        var isNightMode = ifeng.isNightMode();
        if(subState){
            var delSubImg = "delete_sub_detail.png";
            if(isNightMode) {
                delSubImg = "sub_delete_night.png";
            }
            subButton.setAttribute("src", delSubImg);
        }else{
            var addSubImg = "add_sub_detail.png";
            if(isNightMode) {
                addSubImg = "sub_add_night.png";
            }
            subButton.setAttribute("src", addSubImg);
        }
        console.log("subSourceSuccessForDoc");
    };
}

function getWebViewSelectedData(title){
    var value = "";
    if(window.getSelection){
        value = window.getSelection().toString();
    }else if(window.document.getSelection){
        value = window.document.getSelection().toString();
    }else if(window.document.selection){
        value = window.document.selection.createRange.text;
    }
    ifeng.getSelectedText(title,value);
}

function docSelectAll(title){
    var doc = document,
          text = doc.getElementById('ifeng-article'),
          range,
          selection;

      if (doc.body.createTextRange) {
          range = document.body.createTextRange();
          range.moveToElementText(text);
          range.select();
      } else if (window.getSelection) {
          selection = window.getSelection();
          selection.removeAllRanges();

          range = document.createRange();
          range.selectNodeContents(text);
          selection.addRange(range);
      }
      getWebViewSelectedData(title);
}

function isFieldValid(field){
    if(field != null && field != "" && field != 'undefined' && field != undefined ){
        return true
    }
    return false
}

//初始化文章简介
function initSummary(summaryStr) {
    var summaryParent = document.getElementById('summary_parent');
    var summaryContent = document.getElementById('summary');
    if (summaryStr.length > 0) {
        summaryParent.style.display = 'inline-block';
        summaryContent.innerHTML = summaryStr;
    } else {
        summaryParent.style.display = 'none';
    }

}

// 发送日志
function sendWebLog(type, msg, e) {
    var docId = datas.getDocumentId() || 'null doc id',
        eMsg = e && e.message ? e.message : 'null error msg';

    ifeng.webLog(docId + '---' + type + '---' + eMsg + '---' + msg);
}

function dealWithSurveyPlaceHolder(content){
    var surveyListStr = datas.getSurveylistJson();
    if(surveyListStr&&Object.prototype.toString.call(surveyListStr) == '[object String]'){

        var surveyList = JSON.parse(surveyListStr);
        content = handle_survey_position(content,survey_p,surveyList.length,
            function(i) {
                return '<div class="survey_classes" id="survey_content_'+i+'" style="width:100%"></div>';
            });
    }
    return content;
}

function dealWithSurveyContentView(){
    var survey_classes = document.getElementsByClassName("survey_classes");
    if(!survey_classes || survey_classes.length <= 0) {
        return;
    }

    removeNotePreEmptyPBottomSpace("survey_classes");

    renderSurveyContentView(0);
}

function renderSurveyContentView(position) {
    var id = "survey_content_"+position;
    var surveyDiv = document.getElementById(id);
    if(surveyDiv != null && surveyDiv != undefined){
       var top = window.devicePixelRatio*getTop(surveyDiv);
       console.log('dealWithSurvey, position='+position+' id=' + id+' top=' + top);

       ifeng.addSurveyViewToWebView(top,id,position);
    } else {
       //所有调查渲染完毕时，重新定位音频控件的位置
       initAudio();
       console.log('dealWithSurvey, has no survey for position='+position);
    }
}

function changeSurveyDivHeight(height,divId){
    if(!divId) {
        return;
    }

    var surveyDiv = document.getElementById(divId);
    if(surveyDiv != null && surveyDiv != undefined){
      surveyDiv.style.height = height + "px";
      console.log('changeSurveyDivHeight, height='+height+' divId=' + divId);
    }
}

// 修复p内套多个img 以及 p内有small标签
function formatText(text) {
    var fragment = document.createElement('div');
    fragment.innerHTML = text;
    var eles = Array.prototype.slice.call(fragment.getElementsByTagName('p'));
    for ( var i = 0; i < eles.length; i++) {
        var container = eles[i],
            imgs = Array.prototype.slice.call(container.getElementsByTagName('ifengimg'));

        if(container.getElementsByTagName('small').length === 1) {
        	container.className += ' img-note';
        }

        if (imgs.length < 2) {
            continue;
        }
        var frag = document.createDocumentFragment();
        for ( var j = 0; j < imgs.length; j++) {
            var p = document.createElement('p');
            p.appendChild(imgs[j]);
            frag.appendChild(p);
        }
        try{
            fragment.replaceChild(frag, container);
        }catch(e){
        }
    }
    return fragment.innerHTML;
}

/**
 * 处理正文中 文字 部分的<a>标签
 *   注意：图片外层的 <a> 在 processImage 里处理
 */
function dealwithTextAtag (container) {
    var all_a = Array.prototype.slice.call(container.getElementsByTagName('a'));
        for ( var i = 0; i < all_a.length; i++) {
             var tempA = all_a[i];
             var ifenghref = tempA.getAttribute("ifengapp-data");
             var tempHref = tempA.getAttribute("href");
             if (ifenghref != null) {
                 tempA.setAttribute("href", "javascript:void(0);");
                 tempA.onclick = function() {
                   ifeng.popupLightbox(null, -1, this.getAttribute("ifengapp-data"));
                 };
             } else if (tempHref != null) {
                 //如果这个A标签本身是调用一个js方法，则这个A标签不做处理
                 if(tempHref.startsWith("javascript")){
                    continue;
                 }
                 tempA.setAttribute("ifengapp-data", tempHref);
                 tempA.setAttribute("href", "javascript:void(0);");
                 tempA.onclick = function() {
                   ifeng.popupLightbox(null, -1, this.getAttribute("ifengapp-data"));
                 };
             }
        }
}

function initCardAd(){
     var container = document.getElementById('content');
     var cardadComponent = container.getElementsByClassName('cardad');
     for(var i=0;i<cardadComponent.length;i++){
         var cardadDom = cardadComponent[i];
         ifeng.initCardAdLayout(window.devicePixelRatio*(getTop(cardadDom)),i);
         ifeng.setCardAdPosition(offsetTop(cardadDom),i);
     }
}